﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDiagramExportToImageCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += MainWindow_Loaded;
            this.DataContext = new EmployeeViewModel();
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            //this.Width = 2000;
            //this.Height = 2000;

            //this.Width = 500;
            //this.Height = 700;
        }

        private void ExportBtn_Click(object sender, RoutedEventArgs e)
        {           
            int sizeWidth = 2100;
            int sizeHeight = (int)HierarchicalDiagram.ActualHeight;         

            LayoutRoot.Width = sizeWidth;
            LayoutRoot.Height = sizeHeight;            

            LayoutRoot.Measure(new Size(sizeWidth, sizeHeight));
            LayoutRoot.Arrange(new Rect(0, 0, sizeWidth, sizeHeight));

            HierarchicalDiagram.Measure(new Size(sizeWidth, sizeHeight));
            HierarchicalDiagram.Arrange(new Rect(0, 0, sizeWidth, sizeHeight));

            RenderTargetBitmap map = new RenderTargetBitmap(sizeWidth, sizeHeight, 96, 96, PixelFormats.Pbgra32);
            map.Render(LayoutRoot);
            
            LayoutRoot.UpdateLayout();
            HierarchicalDiagram.UpdateLayout();
            
            Dispatcher.BeginInvoke(new Action(() =>
            {
                PngBitmapEncoder png = new PngBitmapEncoder();
                png.Frames.Add(BitmapFrame.Create(map));

                using (Stream s = File.Create("new.png"))
                {
                    png.Save(s);
                }
            }));

            LayoutRoot.Width = double.NaN;
            LayoutRoot.Height = double.NaN;

        }
    }
}
